//RahmenWerteRunden_502d.js
//© 08.12.2020 / Hans Haesler, Châtelard 52, CH-1018 Lausanne
//DESCRIPTION:Die Werte der Rahmen auf Zehntel-Millimeter begradigen
//(die Positionen bleiben unverändert)

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// prüfen, ob ein Dokument geöffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// das Dokument im Vordergrund
var curDoc = app.documents[0];

// die Masseinheiten prüfen
var hM = curDoc.viewPreferences.horizontalMeasurementUnits;
var vM = curDoc.viewPreferences.verticalMeasurementUnits;
if (hM+vM != 4107983590) {
	alert ("Nur sinnvoll mit Masseinheiten \"Millimeter\".", "Stop");
	exit();
}

// die Auswahl speichern und prüfen
var allFrames = app.selection;
var nFrames   = allFrames.length;
if (nFrames == 0) {
	allFrames = curDoc.pageItems;
	nFrames   = allFrames.length;
}

// ein paar Variablen definieren
var curFrame, whatKind, curImage, groupObjects, nObjects, curObj;
var noFrame = 0;

// eine Schleife durch die Rahmen
for (var n=0; n<nFrames; n++) {
	curFrame = allFrames[n];
	whatKind = curFrame.constructor.name;
	curImage = curFrame.allGraphics[0];
	if (whatKind == "Image") {
		noFrame++;
	}
	else if (whatKind == "Group") {
		groupObjects = curFrame.allPageItems;
		nObjects = groupObjects.length;
		for (var g=0; g<nObjects; g++) {
			curObj = groupObjects[g];
			whatKind = curObj.constructor.name;
			curImage = curObj.allGraphics[0];
			if (whatKind != "Image") {
				if (curImage == "[object Image]") {
					processFrame(curObj, "Image");
				}
				else {
					processFrame(curObj, undefined);
				}
			}
		}
	}
	else {
		if (curImage == "[object Image]") {
			processFrame(curFrame, "Image");
		}
		else {
			processFrame(curFrame, undefined);
		}
	}
}
if (noFrame == 1) {
	alert ("Den *Rahmen* des Bildes auswählen!", "");
}
else if (noFrame > 1) {
	alert ("Den *Rahmen* der " + noFrame +" Bilder auswählen!", "");
}

// das Ende der Aktion verkünden
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
// eine kleine Pause
$.sleep(999);
// das Fenster schliessen
dlog.close();


///////////////////////////////////////////////////////////////////////////////////////////////
// die Funktion, welche die Werte des aktuellen Rahmen rundet /////////////////////////////////
function processFrame(curFrame, whatKind) {
	var rA = curFrame.rotationAngle;
	if (rA != 0) {
		curFrame.rotationAngle = 0;
	}
	var isLocked = false;
	if (curFrame.locked) {
		isLocked = true;
		curFrame.locked = false;
	}
	try {
		var vB = curFrame.visibleBounds;
		if (curImage != "[object Image]") {
			var fH = Math.ceil((vB[2]-vB[0])*10)/10;
			var fW = Math.ceil((vB[3]-vB[1])*10)/10;
		}
		else {
			var fH = Math.floor((vB[2]-vB[0])*10)/10;
			var fW = Math.floor((vB[3]-vB[1])*10)/10;
		}
		curFrame.visibleBounds = [vB[0], vB[1], vB[0]+fH, vB[1]+fW];
	}
	catch (e) {
		if (rA != 0) {
			curFrame.rotationAngle = rA;
		}
		return;
	}
	if (rA != 0) {
		curFrame.rotationAngle = rA;
	}
}